CC			= gcc
RM			= rm -f
CCFLAGS		= -ansi -pedantic -c
LINK		= gcc

.PHONY:		all
all:		build

.PHONY:		clean
clean:
			$(RM) *.o 
			$(RM) tony
			$(RM) lex.yy.c
			$(RM) tony.tab.*

.PHONY:		build
build:		clean P3

P3:			main.o bjbu_std.o tonyAST_Make.o tonyCodeOffset.o tonyCodeAsm.o \
tonyAbstractAsm.o tonyAbstractAsmPrint.o tonyAbstractAsmCode.o \
tonyAbstractAsmPeepHole.o tonyAST_Pretty_XML.o tonyAST_Pretty_TXT.o \
tonyWeed.o tonySymbols_Check.o tonySymbols_Build.o tonySymbols_Xref.o \
symbol.o lex.yy.o tony.tab.o
			$(LINK) *.o -o tony

main.o:		main.c bjbu_std.h symbol.h tonyAbstractAsm.h tonyAST.h
			$(CC) $(CCFLAGS) main.c -o main.o

bjbu_std.o:	bjbu_std.c bjbu_std.h
			$(CC) $(CCFLAGS) bjbu_std.c

tonyAST_Make.o:	tonyAST_Make.c bjbu_std.h tonyAST.h tonyAST_Make.h symbol.h
			$(CC) $(CCFLAGS) tonyAST_Make.c

tonyAST_Pretty_XML.o: tonyAST_Pretty_XML.c  bjbu_std.h tonyAST.h symbol.h \
tonyAST_Pretty_XML.h
			$(CC) $(CCFLAGS) tonyAST_Pretty_XML.c

tonyAST_Pretty_TXT.o: tonyAST_Pretty_TXT.c bjbu_std.h tonyAST.h symbol.h \
tonyAST_Pretty_TXT.h
			$(CC) $(CCFLAGS) tonyAST_Pretty_TXT.c

tonyCodeOffset.o: tonyCodeOffset.c bjbu_std.h tonyAST.h symbol.h
			$(CC) $(CCFLAGS) tonyCodeOffset.c

tonyCodeAsm.o: tonyCodeAsm.c bjbu_std.h tonyAST.h symbol.h
			$(CC) $(CCFLAGS) tonyCodeAsm.c

tonyAbstractAsm.o: tonyAbstractAsm.c tonyAbstractAsm.h bjbu_std.h tonyAST.h \
symbol.h
			$(CC) $(CCFLAGS) tonyAbstractAsm.c

tonyAbstractAsmCode.o: tonyAbstractAsmCode.c tonyAbstractAsm.h bjbu_std.h \
tonyAST.h symbol.h
			$(CC) $(CCFLAGS) tonyAbstractAsmCode.c

tonyAbstractAsmPrint.o: tonyAbstractAsmPrint.c tonyAbstractAsm.h bjbu_std.h \
tonyAST.h symbol.h
			$(CC) $(CCFLAGS) tonyAbstractAsmPrint.c

tonyAbstractAsmPeepHole.o: tonyAbstractAsmPeepHole.c tonyAbstractAsm.h \
bjbu_std.h symbol.h
			$(CC) $(CCFLAGS) tonyAbstractAsmPeepHole.c


tonySymbols_Build.o: tonySymbols_Build.c bjbu_std.h symbol.h tonyAST.h
			$(CC) $(CCFLAGS)  tonySymbols_Build.c

tonySymbols_Check.o: tonySymbols_Check.c bjbu_std.h symbol.h tonyAST.h
			$(CC) $(CCFLAGS)  tonySymbols_Check.c

tonySymbols_Xref.o: tonySymbols_Xref.c bjbu_std.h symbol.h tonyAST.h
			$(CC) $(CCFLAGS)  tonySymbols_Xref.c

tonyWeed.o: tonyWeed.c bjbu_std.h tonyAST.h
			$(CC) $(CCFLAGS)  tonyWeed.c

symbol.o:	symbol.c bjbu_std.h symbol.h
			$(CC) $(CCFLAGS) symbol.c

lex.yy.o:	lex.yy.c bjbu_std.h tony.tab.h
			$(CC) $(CCFLAGS) lex.yy.c

tony.tab.o: tony.tab.c tony.tab.h	bjbu_std.h
			$(CC) $(CCFLAGS) tony.tab.c

tony.tab.h:	tony.y bjbu_std.h
			bison  --verbose --defines tony.y

tony.tab.c:	tony.y bjbu_std.h
			bison  --verbose --defines tony.y

lex.yy.c:	tony.lex tony.tab.h bjbu_std.h
			flex tony.lex
