CC			= gcc
RM			= rm -f
CCFLAGS 	= -ansi -pedantic -c
LINK		= gcc
TCHECK = -S -restriktiv -prettyTxt -xref
TCODE = 

.PHONY: 	all
all:		code tonycode sducode com decl stm preced term weed stmtype \
exptype scopetype expand

.PHONY: 	code
code:		clean tonycode

.PHONY: 	sdu
sdu:		clean sducode

.PHONY: 	check
check:		clean com decl stm preced term weed stmtype exptype scopetype \
expand

.PHONY: 	weed_type_check
weed_type_check:	weed stmtype exptype scopetype

.PHONY: 	syntax
syntax: 	com decl stm preced term weed

.PHONY: 	clean
clean:
	$(RM) test_*.txt 
	$(RM) test_*.xml
	$(RM) test_*.*.txt
	$(RM) test_*.*.xml
	$(RM) test_*.s
	$(RM) test_*.o
	$(RM) test_*.exe
	$(RM) test_total.txt

.PHONY: 	tonycode
tonycode:
	runbat code_tony.bat test_code_exp1 test_total $(TCODE)
	runbat code_tony.bat test_code_exp2 test_total $(TCODE)
	runbat code_tony.bat test_code_assign1 test_total $(TCODE)
	runbat code_tony.bat test_code_Suker test_total $(TCODE)
	runbat code_tony.bat test_code_if test_total $(TCODE)
	runbat code_tony.bat test_code_while1 test_total $(TCODE)
	runbat code_tony.bat test_code_while2 test_total $(TCODE)
	runbat code_tony.bat test_code_for1 test_total $(TCODE)
	runbat code_tony.bat test_code_array1 test_total $(TCODE)
	runbat code_tony.bat test_code_array2 test_total $(TCODE)
	runbat code_tony.bat test_code_array2Global test_total $(TCODE)
	runbat code_tony.bat test_code_recordListe test_total $(TCODE)
	runbat code_tony.bat test_code_arrayRecord1a test_total $(TCODE)
	runbat code_tony.bat test_code_arrayRecord1b test_total $(TCODE) \
-noRecordArray
	runbat code_tony.bat test_code_recordArray1a test_total $(TCODE)
	runbat code_tony.bat test_code_recordArray1b test_total $(TCODE) \
-noRecordArray
	runbat code_tony.bat test_code_recordArray2a test_total $(TCODE)
	runbat code_tony.bat test_code_recordArrayCyklisk test_total $(TCODE)
	runbat code_tony.bat test_code_call test_total $(TCODE)

	runbat code_tony.bat test_code_indexHigh test_total $(TCODE)
	runbat code_tony.bat test_code_indexLow test_total $(TCODE)
	runbat code_tony.bat test_code_heapend test_total $(TCODE) -heapSize 20

.PHONY: 	sducode
sducode:
	runbat code_tony.bat test_code_sdu_AbsTest test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_ArrayIndex test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_Assoc test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_ErrOutOfBounds1 test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_ErrOutOfBounds2 test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_Factorial test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_Function $(TCODE)
	runbat code_tony.bat test_code_sdu_IfThen test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_Knapsack test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_SimpleRecord test_total $(TCODE)
	runbat code_tony.bat ttest_code_sdu_StaticLink test_total $(TCODE)
	runbat code_tony.bat test_code_sdu_WhileDo test_total $(TCODE)


.PHONY: 	expand
expand:
	runbat check_tony.bat test_typeminus test_total $(TCHECK)
	runbat check_tony.bat test_typefor1 test_total $(TCHECK)

.PHONY: 	weed
weed:		
	runbat check_tony.bat test_weed1 test_total $(TCHECK) 
	runbat check_tony.bat test_weed2 test_total $(TCHECK) 
	runbat check_tony.bat test_weed3 test_total $(TCHECK) 
	runbat check_tony.bat test_weed4 test_total $(TCHECK) 

.PHONY: 	stmtype
stmtype:		
	runbat check_tony.bat test_typereturn1 test_total $(TCHECK) 
	runbat check_tony.bat test_typereturn2 test_total $(TCHECK) 
	runbat check_tony.bat test_typereturn3 test_total $(TCHECK) 
	runbat check_tony.bat test_typecall1 test_total $(TCHECK) 
	runbat check_tony.bat test_typecall2 test_total $(TCHECK) 
	runbat check_tony.bat test_typeassign1 test_total $(TCHECK) 
	runbat check_tony.bat test_typewrite1 test_total $(TCHECK) 
	runbat check_tony.bat test_typenew1 test_total $(TCHECK) 
	runbat check_tony.bat test_typeif1 test_total $(TCHECK) 
	runbat check_tony.bat test_typewhile1 test_total $(TCHECK) 

.PHONY: 	exptype
exptype:		
	runbat check_tony.bat test_typeexp1 test_total $(TCHECK) 
	runbat check_tony.bat test_typeexp2 test_total $(TCHECK) 
	runbat check_tony.bat test_typeexp3 test_total $(TCHECK) 
	runbat check_tony.bat test_typeexp4 test_total $(TCHECK) 
	runbat check_tony.bat test_typestruct1 test_total $(TCHECK) 
	runbat check_tony.bat test_typearray1 test_total $(TCHECK) 
	runbat check_tony.bat test_typearray2 test_total $(TCHECK) 

.PHONY: 	scopetype
scopetype:		
	runbat check_tony.bat test_typescope1 test_total $(TCHECK) 

.PHONY: 	com
com:		
	runbat check_tony.bat test_com1 test_total $(TCHECK) 
	runbat check_tony.bat test_com2 test_total $(TCHECK) 
	runbat check_tony.bat test_com3 test_total $(TCHECK) 
	runbat check_tony.bat test_com4 test_total $(TCHECK) 

.PHONY: 	decl
decl:		
	runbat check_tony.bat test_decl1 test_total $(TCHECK) 
	runbat check_tony.bat test_decl1b test_total -S -prettyTxt -xref 
	runbat check_tony.bat test_decl2 test_total $(TCHECK) 
	runbat check_tony.bat test_decl3 test_total $(TCHECK) 
	runbat check_tony.bat test_decl4 test_total $(TCHECK) 

.PHONY: 	stm
stm:		
	runbat check_tony.bat test_stm1 test_total $(TCHECK) 
	runbat check_tony.bat test_stm2 test_total $(TCHECK) 
	runbat check_tony.bat test_stm3 test_total $(TCHECK) 
	runbat check_tony.bat test_stm4 test_total $(TCHECK) 

.PHONY: 	preced
preced: 	
	runbat check_tony.bat test_precedens1 test_total $(TCHECK) 
	runbat check_tony.bat test_precedens2 test_total $(TCHECK) 
	runbat check_tony.bat test_precedens3 test_total $(TCHECK) 
	runbat check_tony.bat test_precedens4 test_total $(TCHECK) 

.PHONY: 	term
term:		
	runbat check_tony.bat test_term1 test_total $(TCHECK) -prettyXml

